import pygame
import sys
import numpy as np
import copy
import pickle

pygame.init()
desk_w, desk_h = pygame.display.get_desktop_sizes()[0]
print(desk_w, ',  ', desk_h)

my_font = pygame.font.SysFont(None,int(desk_h/30))    

rng = np.random.default_rng()

screen = pygame.display.set_mode((desk_w, desk_h))  #    Full screen
"""
         教示の表示
"""
msg_img = pygame.image.load('msg_intro.png')
msg_w, msg_h = msg_img.get_size()
print(msg_w, ',  ', msg_h)
screen.fill((255,255,255))
screen.blit(msg_img, ((desk_w - msg_w)//2, (desk_h - msg_h)//2))
pygame.display.flip()
"""
          Enterキーが押されるまで表示
"""
ck = True
while ck:
    for e in pygame.event.get():
        if e.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
        elif e.type == pygame.KEYDOWN:
            if e.key == pygame.K_ESCAPE:     #   Escapeキーを押すと強制終了
                pygame.quit()
                sys.exit()
            elif e.key == pygame.K_RETURN:    #   Enter key pressed?
                ck = False
                break

screen.fill((0,0,0))  

scl_img = int(desk_h / 5)          #   パッチサイズ

"""
　　　大きさの異なる５枚の円盤のイメージをリストL_patchesに格納
"""
L_patches = []
for ip in range(5):
    temp_s = pygame.Surface((scl_img, scl_img))
    c_r = scl_img*0.5*0.2 + 0.8 * scl_img * 0.5 * ip/4
    pygame.draw.circle(temp_s, (255,255,255), (scl_img/2, scl_img/2), c_r)
    L_patches.append(temp_s)
                       
"""
        提示刺激対の組 [[i,j],[s,t]] のリスト
"""
L_trials = [[[1,2],[3,4]], [[2,3],[4,5]],
            [[1,2],[3,5]], [[1,3],[4,5]],
            [[1,3],[2,4]], [[2,4],[3,5]],
            [[1,4],[2,5]], [[1,4],[3,5]],
            [[2,5],[1,3]]]

n_subtrials = len(L_trials)             #   １ブロックの試行数
n_subs = 30                             #   ブロック数
n_wholetrials = n_subs * n_subtrials    #   総試行数

L_res = []       #    提示刺激組と反応のリスト
i_trial = 0      #    試行数
for i_tsubs in range(n_subs):
    rng.shuffle(L_trials)               #   リストのシャフリング
    for i_subs in range(n_subtrials):   
        i_trial += 1
        st = copy.deepcopy(L_trials[i_subs])
        rng.shuffle(st)         #    提示刺激対の上下のシャフリング
        rng.shuffle(st[0])      #    上の対の左右のシャフリング
        rng.shuffle(st[1])      #    下の対の左右のシャフリング

        screen.fill((0,0,0))  
        
        srfc_str = my_font.render(
            f'Difference Scaling: {i_trial}/{n_wholetrials}',
            True, (255,255,255)) 
        str_w, str_h = srfc_str.get_size()
        screen.blit(srfc_str, ((desk_w - str_w)//2, 5))
        pygame.display.flip()
        """
               スペースキーの押下を待つ
        """
        ck = True
        while ck:
            for e in pygame.event.get():
                if e.type == pygame.QUIT:
                    pygame.quit()
                    sys.exit()
                elif e.type == pygame.KEYDOWN:
                    if e.key == pygame.K_ESCAPE:
                        pygame.quit()
                        sys.exit()
                elif e.type == pygame.KEYUP:
                    if e.key == pygame.K_SPACE:
                        ck = False
                        break
        """
                 刺激組の提示
        """
        screen.blit(L_patches[st[0][0]-1],
                    (int(desk_w/2 - scl_img*1.2), int(scl_img)))
        screen.blit(L_patches[st[0][1]-1],
                    (int(desk_w/2 + scl_img*0.2), int(scl_img)))
        screen.blit(L_patches[st[1][0]-1],
                    (int(desk_w/2 - scl_img*1.2), int(3*scl_img)))
        screen.blit(L_patches[st[1][1]-1], (int(desk_w/2 + scl_img*0.2), int(3*scl_img)))
        pygame.display.flip()

        X = None
        ck = True   
        while ck:
            for e in pygame.event.get():
                #print('e =',e)
                if e.type == pygame.QUIT:
                    pygame.quit()
                    sys.exit()
                elif e.type == pygame.KEYDOWN:
                    if e.key == pygame.K_ESCAPE:
                        pygame.quit()
                        sys.exit()
                    elif e.key == pygame.K_UP:
                        X = 1
                        screen.fill((0,0,0)) 
                        pygame.display.flip()
                        ck = False
                        break
                    elif e.key == pygame.K_DOWN:
                        X = 0
                        screen.fill((0,0,0))  
                        pygame.display.flip()
                        ck = False
                        break
                if ck == False:
                   break
        L_res.append([st,X])       #   提示刺激の組と反応の記録
            
pygame.quit()

print(L_res)

fout_csv_nm = input('Output file name (*.csv) = ')
with open(fout_csv_nm, 'w') as f:
    f.write(',i,j,s,t,X\n')
    for i,v in enumerate(L_res):
        print(i, v)
        f.write(f'{i},{v[0][0][0]},{v[0][0][1]},' +
                f'{v[0][1][0]},{v[0][1][1]},{v[1]}\n')
        
print('\n' + fout_csv_nm + ' was saved.\n')
